#
#
# $Id: util2ch.rb,v 1.56 2003/10/29 13:32:59 Yuukis Exp $
#
#

require 'nkf'
require 'open3'
require 'net/http'
Net::HTTP.version_1_2

BBSMenuFile = "#{Root}bbsmenu.html"
S = 'subject.txt'
RubyTooOld =<<TooOld

C.i. System Info:
Rubyɸźե饤֥net/http.rbΥС󤬸Ť褦Ǥ
datcacheݻԶ礬ФޤΤǡǿǤؤ뤳Ȥ򤪴ᤷޤ
TooOld

DownLoadFailed =<<"FAILED"
1: ̵̾ο͡ <sage> : 00/00/00 00:00

 url

 datե˼Ԥޤ
 ܡ󤵤줿dat¤ˤʤäǽޤ
 * ǧˤϾ嵭URL֥饦ˤƳƤ

-----
 C.i. - Compact Interface for 2ch. version #{CiVersion} (#{CiCode})
FAILED

RegexDat = /(.*)<>(.*)<>(.*)<>\s(.*)\s<>/
ConvertStrings = { '&gt;' => '>', '&lt;' => '<' }

module InfoUtil
	def lastInfoRead(file)
	# def infoRead(info)
		fh = open(file)
		last = fh.read
		last.sub!(/Last-Modified: /, '')
		last.chomp!
		fh.close
		return(last)
	end

	def lastInfoWrite(str, file)
	# def infoWrite(str, info)
		last = "Last-Modified: #{str}\n"
		fh = open(file, 'w')
		fh.write last
		fh.close
	end
end

module Profile
	def profileRead
	# def getProfile
		return('unix') unless File.exist?("#{Root}profile")
		var = {}
		profile = IO.readlines("#{Root}profile")
		profile.each {|line|
			a = line.split("=")
			key = a.shift
			value = a.to_s.chomp
			var[key]= value
		}
		return(var['board'])
	end

	def profileWrite(board)
	# def setProfile(board)
		str = ''
		str << "board=#{board}\n"
		open("#{Root}profile", 'w').write str
	end
end

module NetUp
	def netUp
		server = 'wids.net'
		path = '/lab/CiRelease.dat'
		header = {}
		header['User-Agent']= MonazillaUA
		Net::HTTP.start(server, 80) {|http|
			response , = http.get(path, header)

			case response.code
			when '200'  # OK
				#puts response.code
				return([false, '']) if response.body =~ CiVersion
				return([true, response.body])
			else
				#puts 'Can\'t get. Network Problem ?'
				return([false, ''])
			end
		}
	end
end

class String
	def jlength  # from jcode.rb
		self.gsub(/[^\Wa-zA-Z_\d]/, ' ').length
	end

	def jindex(key, pos = false)
		if pos
			a = self.scan(/./em)
			a.slice!(0..pos)
			str = a.join('')
		else
			str = self
		end
		x = ''
		res = str.index(key)
		if res
			str.sub(/(.*?)#{key}/im) { x = $1 }
			s = x.jlength
			if pos
				return(s + pos + 1)
			else
				return(s)
			end
		else
			return(nil)
		end
	end

	def dat2str(lastnum)
		# RegexDat = /(.*)<>(.*)<>(.*)<>\s(.*)\s<>/
		str = ''
		lastnum += 1
		self.each {|line|
			NKF.nkf('-exS', line).gsub!(RegexDat) {
				str << "#{lastnum}: #{$1.dat2txt!} <#{$2}> : #{$3}\n"
				str << "\n#{$4.dat2txt!.addBlank}\n\n-----\n"
			}
			lastnum += 1
		}
		return(str)
	end

	def dat2txt!(sbj = false)
		# ConvertStrings = { '&gt;' => '>', '&lt;' => '<' }
		ConvertStrings.each {|from, to| self.gsub!(from, to)}
		unless sbj
			self.gsub!(/&nbsp;/, ' ')
			self.gsub!(/&thinsp;/, ' ')
			self.gsub!(/&amp;/, '&')
			self.gsub!(/&quot;/, '"')
			self.gsub!(/ <br> /, "\n")
			self.gsub!(/<br>/, "\n")
			self.gsub!(/<a href=.*?>/, '')
			self.gsub!(/<\/a>/, '')
			self.gsub!(/^ +/, '')
			self.gsub!(/ $/, '')
			self.gsub!(/ +/, ' ')
		end
		self
	end

	def dat2title
		NKF.nkf('-exS', self).gsub(/^.*<>/, '')
	end

	def addBlank
		results = ''
		self.each {|line|
			#line.gsub!(/^\s*/, '')
			results << ' '.concat(line)
		}
		return(results)
	end
end

def File.copy(from, to)
	f = open(from, 'r')
	fs = f.read
	f.close

	f = open(to, 'w')
	f.write fs
	f.close
end

class AboneExcepton < StandardError ; end

module HTTPGet
	include InfoUtil

	def parseUri2(uri)
		server = ''
		path = ''
		uri.sub(/http:\/\/(.*?)(\/.*)/) {
			server = $1
			path = $2
		}
		return([server, path])
	end
	
	def httpGetFile(from, to, info, gzip = false, bytes = false)
		header = {}
		header['User-Agent']= MonazillaUA
		header['If-Modified-Since']= lastInfoRead(info) if File.exist?(info)
		header['Accept-Encoding']= 'gzip' if gzip
		header['Range']= bytes if bytes

		server, path = parseUri2(from)
		Net::HTTP.start(server, 80, $cfg['getProxyAddr'], $cfg['getProxyPort']) {|http|
			begin

			response , = http.get(path, header)
			case response.code
			when '304'  # Use Local Copy
				#puts response.code
				return([true, response])
			when '206'  # Partical Content
				if response.body[0] == 10
					return([true, response])
				else
					# "ABone" ?
					raise AboneExcepton
				end
			when '200'  # OK
				#puts response.code
				return([true, response])
			when '416'  # Requested Range Not Satisfiable
				raise AboneExcepton
			else
				#puts 'Can\'t get. Network Problem ?'
				return([false, response])
			end
			rescue Net::ProtoRetriableError => err
				puts RubyTooOld
			rescue AboneExcepton
				header.delete('Range')
				header.delete('If-Modified-Since')
				retry
			end
		}
	end

	def httpGetandLastModify(from, to, info, gzip = false)
		result, response = httpGetFile(from, to, info, gzip)
		case response.code
		when '304'  # Use Local Copy
			#puts response.code
			return([true, response])
		when '200'  # OK
			#puts response.code
			if gzip
				fh = open("#{to}.gz", 'w')
			else
				fh = open(to, 'w')
			end
			fh.write response.body
				fh.close
			if gzip
				i, o, e = Open3.popen3("#{Zcat} #{to}.gz")
				i.close
				File.rename("#{to}.gz", to) if e.readlines != []
			end
			lastInfoWrite(response.header['Last-Modified'], info)
			return([true, response])
		else
			#puts 'Can\'t get. Network Problem ?'
			return([false, response])
		end
	end
end

module BBSMenu  # parseUri, getFovoritesΤ class CiǤƤӽФѤ٤
	include HTTPGet
	include InfoUtil

	def getBBSMenu(bbsmenuInfo = BBSMenuFile + '.info')
		result, response = httpGetandLastModify(BBSMenuURI, BBSMenuFile, bbsmenuInfo)
		return([result, response.code])
	end

	def parseBBSMenu
		bbsNameHash = {}
		getBBSMenu unless File.exist?(BBSMenuFile)
		file = NKF.nkf('-exS', IO.readlines(BBSMenuFile).join)
		file.gsub!(/.*<BR><BR><B>/m, '<BR><BR><B>')
		file.gsub!(/Ʊ.*/m, "Ʊ</A>\n")
		file.gsub!(/<br>/i, '')
		file.gsub!(/<\/B>.*/, '')
		file.gsub!(/^\n/, '')

		bbsmenu = []
		bbsHash = {}

		file.each {|line|
			if line =~ /^<B>/
				bbsmenu << [line.sub(/<B>/, '').chomp, 'C-']
			else
				line.sub!(/<a href=(.*)>(.*)<\/a>/i){ bbsmenu << [$2, $1] }
			end
		}
		bbsmenu.each {|balk, value|
			if value =~ /^http:\/\/(.*)\/(.*)\//
				bbsHash[$2]= $1
			end
		}

		$favorites = []
		$cfg['favoriteBoards'].each {|x|
			uri = "http://#{bbsHash[x]}/#{x}/"
			b = bbsmenu.flatten
			$favorites << [b[b.index(uri) - 1], uri]
		}
		$favorites.reverse_each {|a| bbsmenu.unshift(a) }
		bbsmenu.unshift(['Favorites', 'C-'])
		$bbsHash = bbsHash
		return(bbsmenu)
	end

	def parseUri(uri)  # uri == http://pc.2ch.net/unix/
		server = ''
		board = ''
		uri.sub(/http:\/\/(.*)\/(.*)\/.*/) {
			server = $1
			board = $2
		}
		return([server, board])
	end

	def getFavorite
		return($favorites)
	end
end

class BBSBoard
	include HTTPGet
	include InfoUtil

	def initialize(board)
		@server = $bbsHash[board]
		@board = board
		@bookmark = Bookmark.new(board)
		@abone = Abone.new(board)

		Dir.mkdir("#{Root}#{@board}") unless File.exist?("#{Root}#{@board}")
		Dir.mkdir("#{Root}#{@board}/next/") unless File.exist?("#{Root}#{@board}/next/")
		Dir.mkdir("#{Root}#{@board}/cache/") unless File.exist?("#{Root}#{@board}/cache/")
		deleteOldSubjectsDummy if File.exist?("#{Root}#{@board}/#{S}")
		clean
	end

	def downloadSubjects
		writeOldSubjectsDummy unless File.exist?("#{Root}#{@board}/#{S}")
		File.copy("#{Root}#{@board}/#{S}", "#{Root}#{@board}/next/#{S}.tmp")

		result, response = httpGetandLastModify("http://#{@server}/#{@board}/#{S}",
			"#{Root}#{@board}/next/#{S}", "#{Root}#{@board}/#{S}.last", true)

		unless result  # 㳰ȯrescue٤
			puts 'subject.txt˼Ԥޤ'
			exit
		end

		case response.code
		when '304'
			return(false)
		when '200'
			File.copy("#{Root}#{@board}/#{S}", "#{Root}#{@board}/next/#{S}.old")
			fh = open("#{Root}#{@board}/next/#{S}", 'r')
			str = NKF.nkf('-exS', fh.read)
			fh.close
			fh = open("#{Root}#{@board}/next/#{S}", 'w')
			fh.write str
			fh.close
			if File.stat("#{Root}#{@board}/next/#{S}.old").size < 100
				File.copy("#{Root}#{@board}/next/#{S}", "#{Root}#{@board}/next/#{S}.old")
			end
			return(true)
		end
	end

	def writeOldSubjectsDummy
		fh = open("#{Root}#{@board}/#{S}", 'w')
		fh.write "0000000000.dat<>util2ch (0)\n"
		fh.close
	end

	def deleteOldSubjectsDummy
		if File.stat("#{Root}#{@board}/#{S}").size < 100
			File.unlink("#{Root}#{@board}/#{S}")
			File.unlink("#{Root}#{@board}/#{S}.last") if File.exist?("#{Root}#{@board}/#{S}.last")
		end
	end

	def parseSubjects(fn, type)
		subjects = []
		@titleHash = {} if type != 'old'
		n = 1
		re = /(.*)<>(.*)\((\d*)\)/
		IO.readlines("#{Root}#{@board}/next/#{fn}").each {|thread|
			thread.sub!(re) {
				d = $1 ; t = $2 ; r = $3
				unless @abone.abone?(d)
					subjects << [d, r, n]
					if type != 'old'
						@titleHash[n]= t.dat2txt!(true)
						n += 1
					end
				end
			}
		}
		return(subjects)
	end

	def getSubjects(get = false, word = false, statusfilter = false, bookmark = false)
		updateBookmark
		get = true unless File.exist?("#{Root}#{@board}/#{S}")
		if get
			update = downloadSubjects
		else
			return(parsedSubjectGet(word, statusfilter, bookmark)) if File.exist?("#{Root}#{@board}/#{S}.cache") 
		end
		return(parsedSubjectGet(word, statusfilter, bookmark)) unless update

		results = []
		dregex = /\d*\.dat\.[cache|info|last|post]/
		c = Dir.entries("#{Root}#{@board}/cache/").delete_if {|x| x =~ dregex}
		caches = {}
		c.each {|x| caches[x]= 1}
		newSubjects = parseSubjects("#{S}", 'new')
		oldSubjects = parseSubjects("#{S}.old", 'old')
		@oldSHash = {}
		oldSubjects.each {|k, v, x| @oldSHash[k]= v}

		newSubjects.each {|th|
			# th[0]=> dat No., th[1]=> Re: No., th[2]=> title No.
			if caches.include?(th[0])
				th.unshift("C")
			else
				th.unshift(" ")
			end
			if @oldSHash.include?(th[1]) == false
				th.unshift("N")
			elsif th[2].to_i > @oldSHash[th[1]].to_i
				th.unshift("U")
			else
				th.unshift(" ")
			end
			cached = ''
			cached = cachedThread(th[2]) if caches.include?(th[2])
			th[4, 0]= cached
			th[2, 0]= cacheCompare(th[3], cached)
			th[6] = @titleHash[th[6]]
			results << th
		}
		parsedSubjectSave(results)
		finish
		return(results)
	end

	def cachedThread(dat) #=> ᥽å̾ѹۤ⡣
		# return('') unless File.exist?("#{Root}#{@board}/cache/#{dat}")
		return(IO.readlines("#{Root}#{@board}/cache/#{dat}").size.to_s)
	end

	def cacheCompare(dat, cache)
		return('') if cache == ''
		return('=') if dat.to_i == cache.to_i
		return('+') if dat.to_i > cache.to_i
		return('?')
	end

	def parsedSubjectGet(word = false, statusfilter = false, bookmark = false)
		subjects = []
		array = IO.readlines("#{Root}#{@board}/#{S}.cache")
		array.each {|line|
			th = line.split('<>')
			th[6].gsub!(/&lt;&gt;/, "<>")
			if word
				subjects << th if th[6] =~ /#{word}/ie
			elsif statusfilter
				subjects << th if th[0] == 'U'
			elsif bookmark
				subjects << th if @bookmark.bookmark?(th[3])
			else
				subjects << th unless @abone.abone?(th[3])
			end
		}
		return(subjects)
	end

	def parsedSubjectSave(array)
		str = ''
		array.each {|th|
			th[6].gsub!(/<>/, "&lt;&gt;")
			str << th.join("<>").concat("\n")
		}
		fh = open("#{Root}#{@board}/next/#{S}.cache", 'w')
		fh.write str
		fh.close
	end

	def cachedThreadSave(dat, board)
		str = ''
		oCache = open("#{Root}#{board}/#{S}.cache")
		oldCache = oCache.read
		oCache.close

		oldCache.each {|th|
			if th =~ /#{dat}/
				a = th.split('<>')
				a[1]= 'C'
				a[2]= '='
				a[5]= a[4]
				th = a.join('<>')
			end
			str << th
		}

		nCache = open("#{Root}#{board}/#{S}.cache", 'w')
		nCache.write str
		nCache.close
	end

	def finish
		nexts = Dir.glob("#{Root}#{@board}/next/*")
		nexts.each {|nfn|
			File.rename(nfn, "#{Root}#{@board}/#{File.basename(nfn)}")
		}
	end

	def rollback
		nexts = Dir.glob("#{Root}#{@board}/next/*")
		nexts.each {|nfn|
			File.unlink(nfn)
		}
	end

	alias clean rollback

	def bookmark?(dat)
		@bookmark.bookmark?(dat)
	end

	def addBookmark(dat)
		@bookmark.addBookmark(dat)
	end

	def deleteBookmark(dat)
		@bookmark.deleteBookmark(dat)
	end

	def updateBookmark
		@bookmark.update
	end

	def abone?(dat)
		@abone.abone?(dat)
	end

	def addUserAbone(dat, title)
		@abone.addUserAbone(dat, title)
	end
end

class BBSThread
	include HTTPGet
	include InfoUtil

	def initialize(board, dat)
		@server = $bbsHash[board]
		@board = board
		@dat = dat
		@title = ''
		@bookmark = Bookmark.new(board)
		@abone = Abone.new(board)
		Dir.mkdir("#{Root}#{@board}") unless File.exist?("#{Root}#{@board}")
		Dir.mkdir("#{Root}#{@board}/cache/") unless File.exist?("#{Root}#{@board}/cache/")
	end

	def getThread
		from = "http://#{@server}/#{@board}/dat/#{@dat}"
		to = "#{Root}#{@board}/cache/#{@dat}"
		info = "#{to}.last"

		unless File.exist?(to)
			File.unlink(to+'.last') if File.exist?(to+'.last')
			File.unlink(to+'.cache') if File.exist?(to+'.cache')
		end
		range = false
		if File.exist?(to)
			filesize = File.stat(to).size - 1
			range = "bytes=#{filesize}-"
		end
		cache = to+'.cache'

		result, response = httpGetFile(from, to, info, false, range)
		return([false, 'Download failed.']) if result == false
		case response.code
		when '304'  # Use Local Copy
			unless File.exist?(cache)
				tmp = ''
				n = 0
				open(to, 'r') {|line|
					tmp << line.read.dat2str(n)
					n += 1
				}
				fh = open(cache, 'w')
				fh.write tmp if tmp
					fh.close
			end
		when '206'  # Partical Content
			if response.body[0] == 10
				n = IO.readlines(to).size
				fh = open(to, 'a+')
				tmp  = response.body[1,response.body.size-1]
				fh.write tmp if tmp
					fh.close
				if File.exist?(cache)
					fh = open(cache, 'a+')
					tmp = tmp.dat2str(n)
					fh.write tmp if tmp
						fh.close
				else
					tmp = ''
					n = 0
					open(to, 'r') {|line|
						tmp << line.read.dat2str(n)
						n += 1
					}
					fh = open(cache, 'w')
					fh.write tmp if tmp
						fh.close
				end
				lastInfoWrite(response.header['Last-Modified'], info)
			end
		when '200'  # OK
			fh = open(to, 'w')
			fh.write response.body
				fh.close
			fh = open(cache, 'w')
			tmp = response.body.dat2str(0)
			fh.write tmp if tmp
				fh.close
			lastInfoWrite(response.header['Last-Modified'], info)
		end

		IO.readlines("#{Root}#{@board}/cache/#{@dat}").each {|line|
			@title = NKF.nkf('-exS', line.split('<>').pop).chomp
			break
		}

		fh = open("#{Root}#{@board}/cache/#{@dat}.cache", 'r')
		str = fh.read
		fh.close
		return([str, @title])
	end

	def parseDat
		th = []
		open("#{Root}#{@board}/cache/#{@dat}") {|line|
			NKF.nkf('-exS', line.read).gsub!(/(.*)<>(.*)<>(.*)<>(.*)<>/) {
				th << { 'name' => $1.dat2txt!,
						'mail' => $2,
						'date' => $3,
						#'body' => $4.dat2txt!.addBlank }
						'body' => $4.dat2txt! }
				}
		}
		return(th)
	end

	def rmCache
		to = "#{Root}#{@board}/cache/#{@dat}"
		if File.exist?(to)
			File.unlink(to)
			File.unlink(to+'.last') if File.exist?(to+'.last')
			File.unlink(to+'.cache') if File.exist?(to+'.cache')
		end
	end

	def getStart(board, dat)
		return(false) unless File.exist?("#{Root}#{board}/cache/#{dat}")
		return(getFollowUp(1, board, dat, true))
	end

	def getFollowUp(num, board = @board, dat = @dat, title = false)
		a = IO.readlines("#{Root}#{board}/cache/#{dat}")
		return('No Match.') if num-1 > a.size
		fw = a[num-1].dat2str(num-1)
		return(a[0].dat2title.concat("\n").concat(fw.gsub(/\n-----\n\z/, '').gsub(/<\/b>/, '').gsub(/<b>/, ''))) if title
		x = fw.gsub(/\n-----\n\z/, '').gsub(/<\/b>/, '').gsub(/<b>/, '')
		return('No Match.') if x == ''
		return(x)
	end

	def getFollowUpCache(numStr, board = @board, dat = @dat)
		str = ''
		get = false
		case numStr
		when /(.*)-$/
			num = $1.to_i+1
			IO.readlines("#{Root}#{board}/cache/#{dat}.cache").each {|x|
				get = true if x =~ /^#{num}:.*/
				str << x if get
			}
		end
		return(str)
	end

	def parsedDatSave(str)
		fh = open("#{Root}#{@board}/cache/#{@dat}.cache", 'w')
		fh.write str
		fh.close
	end

	def bookmark?
		@bookmark.update
		@bookmark.bookmark?(@dat)
	end

	def addBookmark
		@bookmark.addBookmark(@dat)
	end

	def deleteBookmark
		@bookmark.deleteBookmark(@dat)
	end

	def abone?
		@abone.abone?(@dat)
	end

	def addUserAbone(title)
		@abone.addUserAbone(@dat, title)
	end
end

class Bookmark  # Abone Ǥ
	def initialize(board)
		@board = board
		update
	end

	def bookmark?(dat)
		return(@bookmark.include?(dat))
	end

	def update
		@bookmark = []
		if File.exist?("#{Root}#{@board}/bookmark.dat")
			a = IO.readlines("#{Root}#{@board}/bookmark.dat")
			a.each {|th| @bookmark << th.chomp }
		end
	end

	def addBookmark(dat)
		update
		@bookmark << dat.chomp
		write
	end

	def deleteBookmark(dat)
		update
		@bookmark.delete(dat)
		write
	end

	def write
		str = ''
		@bookmark.each {|line| str << line + "\n" }
		fh = open("#{Root}#{@board}/bookmark.dat", 'w')
		fh.write str
		fh.close
	end
end

class Abone
	def initialize(board)
		@board = board
		update
	end

	def abone?(dat)
		if @userAbone.assoc(dat)
			return(true)
		else
			return(false)
		end
	end

	def update
		@userAbone = []
		if File.exist?("#{Root}#{@board}/abone.dat")
			a = IO.readlines("#{Root}#{@board}/abone.dat")
			a.each {|th|
				x = th.chomp.split('<>')
				x[1].gsub!(/&lt;&gt;/, "<>")
				@userAbone << x
			}
		end
	end	

	def addUserAbone(dat, title)
		update
		@userAbone << [dat, title.gsub(/<>/, '&lt;&gt;')]
		write
	end	

	def write
		str = ''
		@userAbone.each {|a| str << a.join('<>') + "\n" }
		fh = open("#{Root}#{@board}/abone.dat", 'w')
		fh.write str
		fh.close
	end
end

class CookieExcepton < StandardError ; end
class TimeExcepton < StandardError ; end

module PostMessage2ch  # code from goRua 0.15(Pre). thanks.
	def convert_and_encode(str)
		str=NKF::nkf('-sxE',str)
		return str.gsub(/[^a-zA-Z0-9_.-]/n){sprintf('%%%02X',$&.unpack('C')[0]) }
	end

	def postMessage(server, board, thread, name, mailto, message)
		thread = thread.gsub(/\.dat/, '')
		kakikomu='񤭤'
		kakikomu = convert_and_encode(kakikomu)
		name = convert_and_encode(name)
		mailto = convert_and_encode(mailto)
		message = convert_and_encode(message)
		num_of_trial = 0 
		# time = Time.now.to_i.to_s
		tmp = Time.now - 100
		time = tmp.to_i.to_s
   
		header = {}
		header['User-Agent']= MonazillaUA
		header['X-2ch-UA']= MonazillaUA
		header['Referer']= "http://#{server}/test/read.cgi/#{board}/#{thread}/"
		# header['Referer']= "http://#{server}/#{board}/index2.html"
		header['Content-Type']= 'application/x-www-form-urlencoded'
		header['Cookie']= "NAME=#{name};MAIL=#{mailto}"

		Net::HTTP.start(server, 80, $cfg['postProxyAddr'], $cfg['postProxyPort']){ |http|
			begin
				response , = http.post( "/test/bbs.cgi",
				"submit=#{kakikomu}&FROM=#{name}&mail=#{mailto}&MESSAGE=#{message}&bbs=#{board}&key=#{thread}&time=#{time}",
				header)

				body = NKF::nkf('-exS',response.body)
				#puts body
				if response.code == '200'
				# navi2ch 1.5.1 
					if /񤭤ߤޤ/ =~ body
						return true, '񤭹(1)'
					# elsif /Samba24/ =~ body  # ⤦ɬפʤ
					#	return false,"񤭤߼: Samba˰äޤ"
					elsif /ţңңϣҡ([^<]+)/ =~ body
						return false,"񤭤߼: #{$1}"
					elsif /ţңңϣҡ/ =~ body
						/<b>(.*?)<br>/ =~ body
						return false,"񤭤߼: #{$1}"
					elsif /ţңңϣ - / =~ body
						/ţңңϣ - (.*?)<br>/ =~ body
						return false,"񤭤߼: #{$1}"
					elsif /åʤڤǤ/ =~ body || /\<!-- 2ch_X:cookie --\>/ =~ body
						num_of_trial += 1 
						if num_of_trial < 2
							header['Cookie'] += ';' + response['Set-Cookie']
							raise CookieExcepton
						end
						return false,'񤭤ߥ顼: åʤڤǤ'
					else
						STDERR.print body
						return false,'ν񤭤ߥ顼(1)'
					end
				else
					STDERR.print body
					return false,'ν񤭤ߥ顼(2)'
				end
			rescue Net::ProtoRetriableError
				return true, '쥯ȥڡ--餯񤭤--׳ǧ(2)'
			rescue TimeExcepton
				retry
			rescue CookieExcepton
				retry
			rescue
				# print "㳰ȯ񤭤ޤ줿ɤ狼ޤ\n"
				return false,'㳰ȯ񤭤ޤ줿ɤ狼ޤ'
			end
		}
	end

	def getAAList
		if File.exist?("#{Root}aa.list")
			fn = "#{Root}aa.list"
		else
			fn = "#{$cfg['scriptRoot']}aa.list"
		end
		aalist = IO.readlines(fn)
		return(aalist)
	end

	def postInfoRead(file)
	# def infoRead(info)
		return([[$cfg['defaultName']], [$cfg['defaultMailto']]]) unless File.exist?(file)
		nArray = []
		mArray = []
		fh = open(file)
		post = fh.read
		post.each {|line|
			case line
			when /^Name: (.*)/
				nArray << $1
			when /^Mail: (.*)/
				mArray << $1
			end
		}
		fh.close
		nArray.reverse! ; mArray.reverse!
		nArray << $cfg['defaultName'] unless nArray.include?($cfg['defaultName'])
		mArray << $cfg['defaultMailto'] unless mArray.include?($cfg['defaultMailto'])
		return([nArray, mArray])
	end

	def postInfoWrite(name, mail, file)
	# def infoWrite(name, mail, info)
		if File.exist?(file)
			nArray = IO.readlines(file)
		else
			nArray = []
		end
		nArray.delete_if {|x| x == "Name: #{name}\n" or x == "Mail: #{mail}\n"}
		nArray << "Name: #{name}\n"
		nArray << "Mail: #{mail}\n"
		fh = open(file, 'w')
		fh.write nArray.uniq.join
		fh.close
	end
end

module Filter
	def getFilterList
		fs = Dir.glob("#{$cfg['scriptRoot']}filter/*")
		a = []
		fs.each {|x|
			a << `#{x} -n` if File.executable?(x) && File.file?(x)
		}
		return(a)
	end

	def filtering(name, str)
		fh = open("#{Root}filter.cache", 'w')
		fh.write str
		fh.close

		ff = Dir.glob("#{$cfg['scriptRoot']}filter/*")
		fs = []
		ff.each {|x| fs << x if File.executable?(x) && File.file?(x) }
		fs.each {|x|
			if `#{x} -n` == name
				return(`#{x} #{Root}filter.cache`)
			end
		}
	end
end

module SearchStrings
	def getStrings(board)
		return(['']) unless File.exist?(Root+board+'/searched.dat')
		a = []
		IO.readlines(Root+board+'/searched.dat').each {|x| a << x.chomp }
		return(a) if a.size == 1
		return(a.reverse!)
	end

	def addStrings(board, str)
		unless File.exist?(Root+board+'/searched.dat')
			fh = open(Root+board+'/searched.dat', 'w')
			fh.write('')
			fh.close
		end
		a = []
		IO.readlines(Root+board+'/searched.dat').each {|x| a << x.chomp }
		if a.include?(str)
			a.delete(str)
		else
			while a.size >= $cfg['maxLineOfUrl']
				a.shift
			end
		end
		a << str
		fh = open(Root+board+'/searched.dat', 'w')
		fh.write a.join("\n")
		fh.close
	end
end
